math.randomseed (os.time ())

Music.playFile ("Resources/LuvTakes2/Music.mod",true)

white = Color.new (255,255,255)
black = Color.new (0,0,0)
grey = Color.new (128,128,128)
lime = Color.new (153,204,0)
red = Color.new (255,0,0)

paddle1 = Sound.load ("Resources/LuvTakes2/Paddle1.wav",false)
paddle2 = Sound.load ("Resources/LuvTakes2/Paddle2.wav",false)

TauntBG = Image.load ("Resources/LuvTakes2/TauntBG.png")
P1Score = Image.load ("Resources/LuvTakes2/P1Score.png")
P2Score = Image.load ("Resources/LuvTakes2/P2Score.png")
background = Image.load ("Resources/LuvTakes2/Background.png")

Player = {}
Player[1] = {x = 2, y = 100, speed = 4, score = 100, img = Image.load ("Resources/LuvTakes2/P1Paddle.png")}
Player[2] = {x = 466, y = 100, speed = 4, score = 100, img = Image.load ("Resources/LuvTakes2/P2Paddle.png")}

Ball = {x = 240, y = math.random (60,180), xspeed = -6.2, yspeed = 6, img = Image.load ("Resources/LuvTakes2/Ball.png")}

Healthbar = {}
Healthbar[1] = {y = 10}
Healthbar[2] = {y = 10}

taunts1 = {"You are bantha fodder!", "Bring it on, loser!", "Think you can beat this? Just try!", "I rule and you drool!", "Just give up already!", "I'm barely even trying, geez.", "You know I am better than you!", "Ql'yaH!", "Ghuy'cha!", "What? Little Baby can't take losing?", "Your infantile attempts at winning impress me not.", "You're ugly.", "Wow you are getting owned!", "Don't worry, I will end you quickly.", "You are simply boring me.", "You going to put up a fight any time soon?", "I'll go to sleep now.", "Maybe you should press SELECT?", "Is that all you've got? Pathetic.", "Even if there were two of you you'd still equal 0 for suck."}

taunts2 = {"Oh, I am really good at this!", "Wow, I must be way better than you!", "Someone forgot their eye-hand coordination today.", "I think I'll just go to sleep now.", "Hab SoSll' Quch!", "Come on!", "Just try and block this.", "I am better than you times infinite.", "Ha! That's all I have to say.", "Too slow!", "I eat wimps like you for breakfast.", "It isn't too late to quit.", "I'm going to leave you far behind!", "Did you notice that you suck?","I <3 you for your 'skills.'", "Weeny!", "Bom chicka wah-wow.", "Die fatty, die!"}

oldpad = Controls.read ()

taunt1 = taunts1[math.random (#taunts1)]
taunt2 = taunts2[math.random (#taunts2)]

luvtaunt1 = 1
luvtaunt2 = 1

Resolution = {width = 480, height = 272}

whoScored = nil

paddleSpot = math.random (Player[2].img:height ())

gamestate = "playing"

function drawImages ()
screen:blit (0,0,background)
screen:blit (0,242,TauntBG)
screen:print (5,250,"Luvver 1: "..taunt1,white)
screen:print (5,260,"Luvver 2: "..taunt2,white)
screen:blit (Player[1].x,Player[1].y,Player[1].img)
screen:blit (Player[2].x,Player[2].y,Player[2].img)
screen:blit (Ball.x,Ball.y,Ball.img)
end

function drawScore ()
screen:fillRect (109,11,100,11,grey)
screen:fillRect (261,11,100,11,grey)
screen:fillRect (108,10,100,10,red)
screen:fillRect (260,10,100,10,red)
screen:fillRect (108,10,Player[1].score,Healthbar[1].y,lime)
screen:fillRect (260,10,Player[2].score,Healthbar[2].y,lime)
end

function tauntDisplay ()
if pad:left () and oldpad:left () ~= pad:left () then
	if luvtaunt1 == 1 then
		taunt1 = taunts1[math.random (#taunts1)]
		luvtaunt1 = 0
		
		elseif luvtaunt1 == 0 then
			luvtaunt1 = 1
		end
	end

if pad:circle () and oldpad:circle () ~= pad:circle () then
	if luvtaunt2 == 1 then
		taunt2 = taunts2[math.random (#taunts1)]
		luvtaunt2 = 0
		
		elseif luvtaunt2 == 0 then
			luvtaunt2 = 1
		end
	end
end	

function ballMovement ()
if Ball.y <= 0 then
	Ball.yspeed = 6
end

if Ball.y + Ball.img:height () > Resolution.height then
	Ball.yspeed = -6
end

Ball.x = Ball.x + Ball.xspeed
Ball.y = Ball.y + Ball.yspeed
end

function checkCollision (obj1,obj2)
if (obj1.x + obj1.img:width () > obj2.x) and (obj1.x < obj2.x + obj2.img:width ()) and (obj1.y + obj1.img:height () > obj2.y) and (obj1.y < obj2.y + obj2.img:height ()) then

	if (obj1.y > obj2.y) and obj1.y < (obj2.y + obj2.img:height () / 2) then
	obj1.yspeed = -6.2
	local sound = paddle2
	voice = sound:play ()
	
	else
	obj1.yspeed = 6.2
	local sound = paddle1
	voice = sound:play ()
	end

if obj2 == Player[1] then
	obj1.xspeed = 6.2
	
	else
	obj1.xspeed = -6.2
	end
end
end

function playerMovement ()
if pad:up () and Player[1].y > 0 then
	Player[1].y = Player[1].y - Player[1].speed
end

if pad:down () and Player[1].y < (Resolution.height - Player[1].img:height ()) then
	Player[1].y = Player[1].y + Player[1].speed
end

if pad:triangle () and Player[2].y > 0 then
	Player[2].y = Player[2].y - Player[2].speed
end

if pad:cross () and Player[2].y < (Resolution.height - Player[2].img:height ()) then
	Player[2].y = Player[2].y + Player[2].speed
end

if pad:start () then 
	gamestate = "paused"
end
end

function checkScore ()
if Ball.x < 0 - Ball.img:width () then
	gamestate = "scored"
	Player[1].score = Player[1].score - 10

if Player[2].score < 100 then
	Player[2].score = Player[2].score + 10
end 

whoScored = "l*vver 2"
Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = 6.2
end

if Ball.x > Resolution.width then
	gamestate = "scored"
	Player[2].score = Player[2].score - 10

if Player[1].score < 100 then
	Player[1].score = Player[1].score + 10
end

whoScored = "l*vver 1"
Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = -6
end
end

function hasScored ()
if Player[2].score == 0 then
	Music.stop ()
	dofile "Resources/luvtakes2p1.lua"
	
	elseif Player[1].score == 0 then
	Music.stop ()
	dofile "Resources/luvtakes2p2.lua"
	
	else
	if whoScored == "l*vver 1" then
		screen:blit (0,100,P1Score)
		
		elseif whoScored == "l*vver 2" then
			screen:blit (0,100,P2Score)
		end
end

if pad:r () and pad:l () then
	gamestate = "playing"
	end
	end

function paused ()
button = System.buttonPressed (0)

System.message ("Paused",0)

if button == button then

	gamestate = "playing"
	end
end
	
function gameFunctions ()
drawImages ()
drawScore ()

if gamestate == "playing" then
	tauntDisplay ()
	playerMovement ()
	ballMovement ()
	checkCollision (Ball,Player[1])
	checkCollision (Ball,Player[2])
	checkScore ()
end

if gamestate == "paused" then
	paused ()
end

if gamestate == "menuReturn" then
	menuReturn ()
	end

if gamestate == "scored" then
	hasScored ()
end
	end

while true do
pad = Controls.read ()
screen:clear ()

gameFunctions ()

screen.waitVblankStart ()
screen.flip ()

oldpad = pad

if pad:select () then
	Music.stop ()
	dofile "Resources/menu.lua"
	end
end 